/**
 * Init js
 * Version 1.0
 **/

function initJs($) {
	(this.testimonialButtonJS = function(){
		let 
		owlWrapper       = $('.testimonialWrapper'),
		autoplayDuration = owlWrapper.data('autoplay-duration');
		owlWrapper.owlCarousel({
			loop:true,
			margin:40,
			nav:false,
			dots: true,
			navText:["<i class='fa fa-angle-left'></i>","<i class='fa fa-angle-right'></i>"],
			autoplay: true,
			autoplayTimeout:autoplayDuration,
			smartSpeed: 1000,
			responsive:{
				0:{
					items:1,
				}
			}
		});
	}),
	(this.owlCarouselJs = function () {

		let _this = this;

		$(".home_banner_slider").owlCarousel({
			loop:true,
			margin:20,
			nav:false,
			dots: true,
			navText:["<i class='fa fa-angle-left'></i>","<i class='fa fa-angle-right'></i>"],
			autoplay: true,
			autoplayTimeout:5000,
			smartSpeed: 2000,
			responsive:{
				0:{
					items:1,
				}
			}
		});

		$('.newsWrapper').owlCarousel({
			loop:true,
			nav:true,
			dots:false,
			margin: 20,
			items: 1,
			navText:["<i class='fa fa-angle-left'></i>","<i class='fa fa-angle-right'></i>"],
			autoplay: false,
			autoplayTimeout:5000,
			smartSpeed: 2000,
			responsive : {
				0 : {
					items: 1.2,
					margin: 5,
				},

				600 : {
					items: 1.6,
					margin: 10,
				},

				768 : {
					items: 1.4,
				},
				1025 : {
					items: 2.6,
				}
			}

		});

		$('.imageSliderWrapper').owlCarousel({
			loop:true,
			nav:true,
			dots:false,
			margin: 0,
			items: 1,
			navText:["<i class='fa fa-angle-left'></i>","<i class='fa fa-angle-right'></i>"],
			autoplay: false,
			autoplayTimeout:5000,
			smartSpeed: 2000,
			responsive : {
				0 : {
					items: 1
				},
				768 : {
					items: 1
				},
				1025 : {
					items: 1.05,
				}
			}

		});
	}),
	(this.teamPopupJs = function(){
		$("a.btn_popup").click(function(){
			$("#popup-container").addClass("active_popup");
			$("body").addClass("popup_active");
		});

		$(document).on('click', '#btn_close, .overlay_', function(e) {
			e.preventDefault();
			$("#popup-container").removeClass("active_popup");
			$("body").removeClass("popup_active");
		});
	}),
	(this.teamModalAjaxJS = function() {
		$(document).on('click', 'a.btn_popup', function(e) {
			e.preventDefault();

			var 
			id     = $(this).data('id');

			if(!id) return false;

			$.ajax({
				url: ajax_url,
				type: 'POST',
				dataType: 'html',
				data: {action: 'team_popup', id:id},
				beforeSend: function() {
					// $('#popup-container .modal').css({'background': 'transparent'});
					$('#popup-container .modal').html('<div class="loader"></div>');
				},
				success: function(message) {
					// $('#popup-container .modal').css({'background': 'url('+modal_bg_image+')'});
					$('#popup-container .modal').html(message);
				},
				failed: function() {
					// $('#popup-container .modal').css({'background': 'url('+modal_bg_image+')'});
					$('#popup-container .modal').html('<p>Error Occured!</p>');
				}
			})
		});
	}),
	(this.inputfileCustom = function() {
		$("input[type=file]").change(function (e) {
			$(this).parents(".upload_file label").find(".file_text").text(e.target.files[0].name);
		});$
	}),
	(this.mobilemenuJS = function() {
		$(".mobile_menu_bar_toggle").click(function () {
			$("body").toggleClass('menu_active');
		});$
	}),
	(this.appendTriangleArrowjs = function() {
		$(".triangle,.wrapper-ceo .img_wrap").append('<span class="triangle_arrow"></span>');
	}),
	(this.parallaxTringlejs = function() {
		  //parallax scroll
		var parallaxElement = $(".green_triangle .triangle_arrow, .triangle_left .triangle_arrow, .wrapper-ceo .img_wrap .triangle_arrow, .flip_triangle .triangle_arrow"),
		parallaxQuantity = parallaxElement.length;
		window.requestAnimationFrame(function() {
			for (var i = 0; i < parallaxQuantity; i++) {
				var currentElement = parallaxElement.eq(i),
				windowTop = $(window).scrollTop(),
				elementTop = currentElement.offset().top,
				elementHeight = currentElement.height(),
				viewPortHeight = window.innerHeight * 0.2 + elementHeight * 0.2;
				scrolled = windowTop - elementTop + viewPortHeight;
				currentElement.css({
					transform: "translate3d(0," + scrolled * + 0.1 + "px, 0)"
				});
			}

		});
	}),
	(this.parallaxImagejs = function() {
		var parallaxElementImage = $(".parallax_image, .page_Banner_triangle"),
		parallaxQuantity = parallaxElementImage.length;
		window.requestAnimationFrame(function() {
			for (var i = 0; i < parallaxQuantity; i++) {
				var currentElement = parallaxElementImage.eq(i),
				windowTop = $(window).scrollTop(),
				elementTop = currentElement.offset().top,
				elementHeight = currentElement.height(),
				viewPortHeight = window.innerHeight * 0.2 + elementHeight * 0.2;
				scrolled = windowTop - elementTop*0.05 - viewPortHeight*0.05;
				currentElement.css({
					transform: "translate3d(0," + scrolled * + 0.28 + "px, 0)"
				});
			}

		});
	}),
	(this.reveal = function() {
		var reveals = document.querySelectorAll(".inview,.team_innerWrapper .item");

		for (var i = 0; i < reveals.length; i++) {
			var windowHeight = window.innerHeight;
			var elementTop = reveals[i].getBoundingClientRect().top;
			var elementVisible = 150;

			if (elementTop < windowHeight - elementVisible) {
				reveals[i].style.transform = "translateY(0)";
				reveals[i].style.opacity = "1";
			} else {
				reveals[i].style.transitionProperty = "opacity, -webkit-transform, -moz-transform, -ms-transform, -o-transform, transform";
				reveals[i].style.transitionDuration = "800ms";
				reveals[i].style.webkitTransform = "translateY(30px)";
				reveals[i].style.mozTransform = "translateY(30px)";
				reveals[i].style.msTransform = "translateY(30px)";
				reveals[i].style.oTransform = "translateY(30px)";
				reveals[i].style.transform = "translateY(30px)";
				reveals[i].style.transitionDelay = "100ms";
				reveals[i].style.opacity = "0";
			}
		}
	});
	(this.parallaxTopjs = function() {
		  //parallax scroll
		var parallaxElement = $(".mix_triangle, #job_roles_section .triangle_arrow"),
		parallaxQuantity = parallaxElement.length;
		window.requestAnimationFrame(function() {
			for (var i = 0; i < parallaxQuantity; i++) {
				var currentElement = parallaxElement.eq(i),
				windowTop = $(window).scrollTop(),
				elementTop = currentElement.offset().top,
				elementHeight = currentElement.height(),
				viewPortHeight = window.innerHeight * 0.3 + elementHeight * 0.3;
				scrolled = windowTop - elementTop;
				currentElement.css({
					transform: "translate3d(0," + scrolled * - 0.05 + "px, 0)"
				});
			}

		});
	}),
	(this.scrollElementJs = function() {
		$('.button_apply').on('click', function(e) {
			e.preventDefault();
			sessionStorage.setItem('scrollToJoinForm', 'true');
			var targetURL = $(this).attr('data-href');
			window.location.href = targetURL;
		});
	}),

	(this.parallaxImagebottomjs = function() {
		var parallaxElementImage = $(".image_bottom"),
		parallaxQuantity = parallaxElementImage.length;
		window.requestAnimationFrame(function() {
			for (var i = 0; i < parallaxQuantity; i++) {
				var currentElement = parallaxElementImage.eq(i),
				windowTop = $(window).scrollTop(),
				elementTop = currentElement.offset().top,
				elementHeight = currentElement.height(),
				viewPortHeight = window.innerHeight * 0.5 + elementHeight * 0.5;
				scrolled = windowTop - elementTop + elementHeight;
				currentElement.css({
					transform: "translate3d(0," + scrolled * + 0.15 + "px, 0)"
				});
			}

		});

	  	// Add parallax scrolling to all images in .paralax-image container
	  	// $('.image_bottom').each(function(){
			 //    // only put top value if the window scroll has gone beyond the top of the image
			 //    if ($(this).offset().top < $(window).scrollTop()) {
	   //    			// Get ammount of pixels the image is above the top of the window
	   //    			var difference = $(window).scrollTop() - $(this).offset().top;
				//       // Top value of image is set to half the amount scrolled
				//       // (this gives the illusion of the image scrolling slower than the rest of the page)
				//       var half = (difference / 3) + 'px',
				//       transform = 'translate3d( 0, ' + half + ',0)';

				//       $(this).find('img').css('transform', transform);
				//   } else {
				//       // if image is below the top of the window set top to 0
				//       $(this).find('img').css('transform', 'translate3d(0,0,0)');
				//   }
				// });
	}),

	(this.tabContentHeight = function(){
		$(".et_pb_all_tabs .et_pb_tab").map((item, index)=>{
			const len = item.length;
			console.log(len);
		});
	}),

	(this.init = function () {
		let main = this;
		this.owlCarouselJs();
		this.testimonialButtonJS();
		this.teamPopupJs();
		this.teamModalAjaxJS();
		this.inputfileCustom();
		this.mobilemenuJS();
		this.appendTriangleArrowjs();
		this.scrollElementJs();
		this.tabContentHeight();
		$(window).on("load scroll", function() {
			main.parallaxTringlejs();
			main.parallaxImagejs();
			main.reveal();
			main.parallaxTopjs();
			main.parallaxImagebottomjs();

		});

	});
}

try {
	jQuery(function ($) {
		let initObj = new initJs($);
		initObj.init();
	});
} catch (err) {
	console.log(err.message);
}



